/*
 *  webApp引擎 v1.0
 *
 */

//sdk全局变量
var wa = null;
//url协议前缀
var C_WA_SCHEME = "wa://";



/*------------------------------------------------------------------------------
 |  初始化
 |
 ------------------------------------------------------------------------------*/
function iniWa(arg){
    wa = new Wa(arg);
    //调用启动函数
    if (isExitsFunction("startWa")) {
        startWa();
    }
}



/*------------------------------------------------------------------------------
 |  Wa对象
 |
 ------------------------------------------------------------------------------*/
//sdk对象
function Wa(obj){
    //App参数
    this.appParams = null;
    //函数回调
    this.funcCallback = null;
    //事件
    this.onAfterPageNavBack = null;
    //保存到缓存的值
    this.textForsaveToCache = "";
    
    //初始化参数
    this.iniObj(obj);
}

//初始化参数
Wa.prototype.iniObj = function (obj) {
    if (obj==undefined) obj={};
    //App参数
    this.appParams = new WaAppParams(obj);
}

//保存回调
Wa.prototype.saveFuncCallback = function (callback) {
    if (callback!=undefined) {
        this.funcCallback = callback;
    } else {
        this.funcCallback = null;
    }
}

//执行回调
Wa.prototype.invokeFuncCallback = function (obj) {
    if (this.funcCallback!=undefined && this.funcCallback!=null) {
        if (obj==undefined || obj==null) {
            this.funcCallback();
        } else {
            this.funcCallback(obj);
        }
        this.funcCallback = null;
    }
}

//页面返回
Wa.prototype.navBack = function (obj) {
    if (obj==undefined) obj={};
    var navStyle = "default";
    var param = "";
    //navStyle
    if (obj.navStyle!=undefined) {
        navStyle = obj.navStyle;
    }
    //param
    if (obj.param!=undefined) {
        param = obj.param;
    }
    //跳转
    var jo = {
        navStyle:navStyle,
        param:param
    };
    var url = C_WA_SCHEME+"navBack/"+urlEncode(JSON.stringify(jo));
    window.location.href = url;
}

//从上个webapp页返回
Wa.prototype.finishAfterPageNavBack = function (obj) {
    var pack = new WaJsonResultPack(obj);
    var param = "";
    if (pack.obj.param!=undefined) {
        param = pack.obj.param;
    }
    //回调
    if (this.onAfterPageNavBack!=undefined && this.onAfterPageNavBack!=null) {
        this.onAfterPageNavBack(param);
    }
}

//上传图片
Wa.prototype.uploadPic = function (obj,callback) {
    if (obj==undefined) obj={};
    var uuid = "";
    var selectType = "default";
    var maxSelectPicNum = 1;
    //uuid
    if (obj.uuid!=undefined) {
        uuid = obj.uuid;
    }
    //selectType
    if (obj.selectType!=undefined) {
        selectType = obj.selectType;
    }
    //maxSelectPicNum
    if (obj.maxSelectPicNum!=undefined) {
        maxSelectPicNum = obj.maxSelectPicNum;
    }
    
    //回调
    this.saveFuncCallback(callback);
    
    //跳转
    var jo = {
        uuid:uuid,
        selectType:selectType,
        maxSelectPicNum:maxSelectPicNum
    };
    var url = C_WA_SCHEME+"uploadPic/"+urlEncode(JSON.stringify(jo));
    window.location.href = url;
}
Wa.prototype.finishUploadPic = function (obj) {
    var pack = new WaJsonResultPack(obj);
    //回调
    this.invokeFuncCallback(pack);
}

//更新App参数
Wa.prototype.updateAppParams = function (callback) {
    //回调
    this.saveFuncCallback(callback);
    //跳转
    var url = C_WA_SCHEME+"updateAppParams";
    window.location.href = url;
}
Wa.prototype.finishUpdateAppParams = function (obj) {
    var pack = new WaJsonResultPack(obj);
    //更新App参数
    this.appParams = new WaAppParams(pack.obj);
    //执行回调
    this.invokeFuncCallback();
}

//保存图片
Wa.prototype.downloadPic = function (obj,callback) {
    if (obj==undefined) obj={};
    var picUrl = "";
    //picUrl
    if (obj.picUrl!=undefined) {
        picUrl = obj.picUrl;
    }
    //回调
    this.saveFuncCallback(callback);
    //跳转
    var jo = {
        picUrl:picUrl
    };
    var url = C_WA_SCHEME+"downloadPic/"+urlEncode(JSON.stringify(jo));
    window.location.href = url;
}
Wa.prototype.finishDownloadPic = function (obj) {
    var pack = new WaJsonResultPack(obj);
    //回调
    this.invokeFuncCallback(pack);
}

//登录
Wa.prototype.login = function (callback) {
    //回调
    this.saveFuncCallback(callback);
    //跳转
    var url = C_WA_SCHEME+"login";
    window.location.href = url;
}
Wa.prototype.finishLogin = function (obj) {
    var pack = new WaJsonResultPack(obj);
    //更新App参数中的用户信息
    if (pack.code==200) {
        this.appParams.userInfo = new WaUserInfoData(pack.obj);
    }
    //执行回调
    this.invokeFuncCallback(pack);
}

//登出
Wa.prototype.logout = function (callback) {
    //回调
    this.saveFuncCallback(callback);
    //跳转
    var url = C_WA_SCHEME+"logout";
    window.location.href = url;
}
Wa.prototype.finishLogout = function () {
    //更新App参数中的用户信息
    this.appParams.userInfo = new WaUserInfoData();
    //执行回调
    this.invokeFuncCallback();
}

//分享
Wa.prototype.share = function (obj,callback) {
    if (obj==undefined) obj={};
    var uuid = "";
    var sms = true;
    var email = true;
    var weibo = true;
    var weixin = true;
    var pengyouquan = true;
    //uuid
    if (obj.uuid!=undefined) {
        uuid = obj.uuid;
    }
    //sms
    if (obj.sms!=undefined) {
        sms = obj.sms;
    }
    //email
    if (obj.email!=undefined) {
        email = obj.email;
    }
    //weibo
    if (obj.weibo!=undefined) {
        weibo = obj.weibo;
    }
    //weixin
    if (obj.weixin!=undefined) {
        weixin = obj.weixin;
    }
    //pengyouquan
    if (obj.pengyouquan!=undefined) {
        pengyouquan = obj.pengyouquan;
    }
    
    //回调
    this.saveFuncCallback(callback);
    //跳转
    var jo = {
        uuid:uuid,
        sms:sms,
        email:email,
        weibo:weibo,
        weixin:weixin,
        pengyouquan:pengyouquan
    };
    var url = C_WA_SCHEME+"share/"+urlEncode(JSON.stringify(jo));
    window.location.href = url;
}
Wa.prototype.finishShare = function (obj) {
    var pack = new WaJsonResultPack(obj);
    //执行回调
    this.invokeFuncCallback(pack);
}

//查看图片
Wa.prototype.viewPic = function (obj,callback) {
    if (obj==undefined) obj={};
    //回调
    this.saveFuncCallback(callback);
    //跳转
    var url = C_WA_SCHEME+"viewPic/"+urlEncode(JSON.stringify(obj));
    window.location.href = url;
}
Wa.prototype.finishViewPic = function () {
    //回调
    this.invokeFuncCallback();
}

//保存到缓存
Wa.prototype.saveTextToCache = function (obj,callback) {
    if (obj==undefined) obj={};
    var key = "";
    var text = "";
    //key
    if (obj.key!=undefined) {
        key = obj.key;
    }
    //text
    if (obj.text!=undefined) {
        text = obj.text;
    }
    
    //回调
    this.saveFuncCallback(callback);
    
    //保存到缓存的值
    this.textForsaveToCache = text;
    
    //跳转
    var jo = {
        key:key
    };
    var url = C_WA_SCHEME+"saveTextToCache/"+urlEncode(JSON.stringify(jo));
    window.location.href = url;
}
Wa.prototype.getSaveTextToCacheText = function (obj,callback) {
    return this.textForsaveToCache;
}
Wa.prototype.getSaveTextToCacheTextForAndroid = function (obj,callback) {
    androidWa.getSaveTextToCacheText(this.textForsaveToCache);
}



Wa.prototype.finishSaveTextToCache = function (obj) {
    var pack = new WaJsonResultPack(obj);
    //执行回调
    this.invokeFuncCallback(pack);
}

//从缓存中获取文本
Wa.prototype.getTextFromCache = function (obj,callback) {
    if (obj==undefined) obj={};
    var key = "";
    //key
    if (obj.key!=undefined) {
        key = obj.key;
    }
    
    //回调
    this.saveFuncCallback(callback);
    
    //跳转
    var jo = {
        key:key
    };
    var url = C_WA_SCHEME+"getTextFromCache/"+urlEncode(JSON.stringify(jo));
    window.location.href = url;
}
Wa.prototype.finishGetTextFromCache = function (obj) {
    var pack = new WaJsonResultPack(obj);
    //执行回调
    this.invokeFuncCallback(pack);
}

//http请求
Wa.prototype.httpQuery = function (obj,callback) {
    if (obj==undefined) obj={};
    var type = "get";
    var name = "";
    var param = "";
    //type
    if (obj.type!=undefined) {
        type = obj.type;
    }
    //name
    if (obj.name!=undefined) {
        name = obj.name;
    }
    //param
    if (obj.param!=undefined) {
        param = obj.param;
    }
    
    //回调
    this.saveFuncCallback(callback);
    
    //跳转
    var jo = {
        type:type,
        name:name,
        param:param
    };
    var url = C_WA_SCHEME+"httpQuery/"+urlEncode(JSON.stringify(jo));
    window.location.href = url;
}
Wa.prototype.finishHttpQuery = function (obj,callback) {
    var pack = new WaJsonResultPack(obj);
    //执行回调
    this.invokeFuncCallback(pack);
}



/*------------------------------------------------------------------------------
 |  对象
 |
 ------------------------------------------------------------------------------*/
//WaJsonResultPack
function WaJsonResultPack(obj) {
    //200：成功  其他：错误代码
    this.code = 500;
    //提示
    this.msg = "";
    //对象
    this.obj = {};
    
    //初始化参数
    this.iniObj(obj);
}
WaJsonResultPack.prototype.iniObj = function (obj) {
    if (obj==undefined) obj={};
    //200：成功  其他：错误代码
    if (obj.code!=undefined) {
        this.code = obj.code;
    }
    //提示
    if (obj.msg!=undefined) {
        this.msg = obj.msg;
    }
    //对象
    if (obj.obj!=undefined) {
        this.obj = obj.obj;
    }
}

//WaUploadPicResultListDTO
function WaUploadPicResultListDTO(obj) {
    //消息列表
    this.list = new Array();
    
    //初始化参数
    this.iniObj(obj);
}
WaUploadPicResultListDTO.prototype.iniObj = function (obj) {
    if (obj==undefined) obj={};
    //消息列表
    if (obj.list!=undefined) {
        for (var i=0;i<obj.list.length;i++) {
            var o = obj.list[i];
            this.list[i] = new WaUploadPicData(o);
        }
    }
}

//WaUploadPicData
function WaUploadPicData(obj) {
    //图片url
    this.picUrl = "";
    //大图url
    this.bigPicUrl = "";
    //缩略图宽
    this.picWidth = 0;
    //缩略图高
    this.picHeight = 0;

    //初始化参数
    this.iniObj(obj);
}
WaUploadPicData.prototype.iniObj = function (obj) {
    if (obj==undefined) obj={};
    //图片url
    if (obj.picUrl!=undefined) {
        this.picUrl = obj.picUrl;
    }
    //大图url
    if (obj.bigPicUrl!=undefined) {
        this.bigPicUrl = obj.bigPicUrl;
    }
    //缩略图宽
    if (obj.picWidth!=undefined) {
        this.picWidth = obj.picWidth;
    }
    //缩略图高
    if (obj.picHeight!=undefined) {
        this.picHeight = obj.picHeight;
    }
}

//WaAppParams
function WaAppParams(obj){
    //设备名称  iphone或者android
    this.deviceName = "";
    //设备版本号 eg:8.3
    this.deviceVersion = "";
    //设备类型 eg:iphone7,1
    this.deviceType = "";
    //设备唯一标志
    this.deviceNumber = "";
    //屏幕宽度
    this.screenWidth = "";
    //屏幕高度
    this.screenHeight = "";
    //软件版本
    this.appVersion = "";
    //城市id
    this.cityId = "";
    //经度
    this.lon = "";
    //纬度
    this.lat = "";
    //渠道号
    this.sellChannelNumber = "";
    //是否有wifi
    this.isWifi = "";
    //用户
    this.userInfo = new WaUserInfoData();
    //校验码
    this.verifyCode = "";
    //页面参数
    this.pageParam = "";
    //服务器时间差
    this.serverDiffTimestamp = "";
    //webApp引擎版本
    this.engineVersion = "";
    
    //初始化参数
    this.iniObj((obj));
}
WaAppParams.prototype.iniObj = function (obj) {
    if (obj==undefined) obj={};
    //设备名称  iphone或者android
    if (obj.deviceName!=undefined) {
        this.deviceName = obj.deviceName;
    }
    //设备版本号 eg:8.3
    if (obj.deviceVersion!=undefined) {
        this.deviceVersion = obj.deviceVersion;
    }
    //设备类型 eg:iphone7,1
    if (obj.deviceType!=undefined) {
        this.deviceType = obj.deviceType;
    }
    //设备唯一标志
    if (obj.deviceNumber!=undefined) {
        this.deviceNumber = obj.deviceNumber;
    }
    //屏幕宽度
    if (obj.screenWidth!=undefined) {
        this.screenWidth = obj.screenWidth;
    }
    //屏幕高度
    if (obj.screenHeight!=undefined) {
        this.screenHeight = obj.screenHeight;
    }
    //软件版本
    if (obj.appVersion!=undefined) {
        this.appVersion = obj.appVersion;
    }
    //城市id
    if (obj.cityId!=undefined) {
        this.cityId = obj.cityId;
    }
    //经度
    if (obj.lon!=undefined) {
        this.lon = obj.lon;
    }
    //纬度
    if (obj.lat!=undefined) {
        this.lat = obj.lat;
    }
    //渠道号
    if (obj.sellChannelNumber!=undefined) {
        this.sellChannelNumber = obj.sellChannelNumber;
    }
    //是否有wifi
    if (obj.isWifi!=undefined) {
        this.isWifi = obj.isWifi;
    }
    //用户
    if (obj.userInfo!=undefined) {
        this.userInfo = new WaUserInfoData(obj.userInfo);
    }
    //校验码
    if (obj.verifyCode!=undefined) {
        this.verifyCode = obj.verifyCode;
    }
    //页面参数
    if (obj.pageParam!=undefined) {
        this.pageParam = obj.pageParam;
    }
    //服务器时间差
    if (obj.serverDiffTimestamp!=undefined) {
        this.serverDiffTimestamp = obj.serverDiffTimestamp;
    }
    //webApp引擎版本
    if (obj.engineVersion!=undefined) {
        this.engineVersion = obj.engineVersion;
    }
}

//WaUserInfoData
function WaUserInfoData(obj) {
    //用户id
    this.uuid = "";
    //用户真实姓名
    this.trueName = "";
    //用户昵称
    this.nickName = "";
    //手机号
    this.tel = "";
    //用户token
    this.token = "";
    //头像
    this.picUrl = "";
    //用户性别  约定  1：先生  0：女士
    this.sexTag = "";
    
    //初始化参数
    this.iniObj(obj);
}
WaUserInfoData.prototype.iniObj = function (obj) {
    if (obj==undefined) obj={};
    //用户id
    if (obj.uuid!=undefined) {
        this.uuid = obj.uuid;
    }
    //用户真实姓名
    if (obj.trueName!=undefined) {
        this.trueName = obj.trueName;
    }
    //用户昵称
    if (obj.nickName!=undefined) {
        this.nickName = obj.nickName;
    }
    //手机号
    if (obj.tel!=undefined) {
        this.tel = obj.tel;
    }
    //用户token
    if (obj.token!=undefined) {
        this.token = obj.token;
    }
    //头像
    if (obj.picUrl!=undefined) {
        this.picUrl = obj.picUrl;
    }
    //用户性别  约定  1：先生  0：女士
    if (obj.sexTag!=undefined) {
        this.sexTag = obj.sexTag;
    }
}



/*------------------------------------------------------------------------------
 |  对象
 |
 ------------------------------------------------------------------------------*/
//判断函数是否存在
function isExitsFunction(funcName) {
    try {
        if (typeof(eval(funcName)) == "function") {
            return true;
        }
    } catch(e) {
    }
    return false;
}

//urlEncode
function urlEncode(str) {
    str = (str + '').toString();
    return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').
                                                                replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/%20/g, '+');
}




